<template>
  <FloatingCreateButton
    :shown="isShown"
    @click="isShown = true"
  />

  <v-dialog
    v-model="isShown"
    persistent
  >
    <FloatingContainer>
      <FormHeader
        icon="mdi-plus"
        headline="Создание пользователя"
        subtitle="Заполните данные"
      />

      <section class="pt-4">
        <FormRow label="Придумайте логин">
          <v-text-field
            v-model="login"
            :rules="[validateLogin]"
            :maxlength="MAX_LOGIN_LENGTH"
            placeholder="Логин"
            @keydown.space.prevent
          />
        </FormRow>

        <FormRow label="Создайте PIN">
          <PinInput
            v-model="pin"
            :autofocus="false"
            class="border-2 border-dashed"
          />

          <Feedback
            :message="feedback"
            type="error"
            classes="mt-4"
          />
        </FormRow>

        <FormRow spacing="large">
          <v-btn
            block
            rounded
            size="large"
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            :class="{ 'opacity-50': !isDataFilled }"
            :readonly="!isDataFilled"
            :loading="isLoading"
            @click="onCreateClick"
          >
            Создать
          </v-btn>
        </FormRow>

        <FormRow>
          <v-btn
            block
            rounded
            size="small"
            variant="plain"
            :ripple="false"
            class="font-bold"
            @click="isShown = false"
          >
            Отмена
          </v-btn>
        </FormRow>
      </section>
    </FloatingContainer>
  </v-dialog>
</template>

<script setup lang="ts">
import { computed, ref, watch } from 'vue';

import FormRow from '@/components/layout/FormRow.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import FloatingContainer from '@/components/layout/FloatingContainer.vue';
import FloatingCreateButton from '@/components/layout/FloatingCreateButton.vue';

import PinInput from '@/components/content/PinInput.vue';
import Feedback from '@/components/content/Feedback.vue';

import { useUsersStore } from '@/stores';
import { createStringValidator } from '@/validators';
import { MIN_LOGIN_LENGTH, MAX_LOGIN_LENGTH } from '@/declarations';

const usersStore = useUsersStore();
const validateLogin = createStringValidator({
  required: true,
  length: { min: MIN_LOGIN_LENGTH, max: MAX_LOGIN_LENGTH },
});

const isLoading = ref(false);
const feedback = ref('');

const isShown = ref(false);
const login = ref('');
const pin = ref('');

const isDataFilled = computed(() => {
  const isLoginEntered = validateLogin(login.value) === true;
  const isPinEntered = pin.value.length === 4;

  return isLoginEntered && isPinEntered;
});

const onCreateClick = async () => {
  isLoading.value = true;
  feedback.value = '';

  const { data: { error } } = await usersStore.createUser({
    login: login.value,
    pin: pin.value,
  });

  isLoading.value = false;

  if (error) {
    feedback.value = error.message;
    return;
  }

  isShown.value = false;
};

watch(isShown, () => {
  login.value = '';
  pin.value = '';
  feedback.value = '';
});
</script>